package com.realnet.founder's_friend.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.founder's_friend.Entity.Expenses;
import com.realnet.founder's_friend.Services.ExpensesService ;






@RequestMapping(value = "/Expenses")
 @CrossOrigin("*") 
@RestController
public class ExpensesController {
	@Autowired
	private ExpensesService Service;

@Value("${projectPath}")
	private String projectPath;
 






	@PostMapping("/Expenses")
		  public Expenses Savedata(@RequestBody Expenses data) {
		Expenses save = Service.Savedata(data)	;





		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Expenses/{id}")
	public  Expenses update(@RequestBody Expenses data,@PathVariable Integer id ) {
		Expenses update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Expenses/getall/page")
	public Page<Expenses> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Expenses> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Expenses")
	public List<Expenses> getdetails() {
		 List<Expenses> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Expenses")
	public List<Expenses> getallwioutsec() {
		 List<Expenses> get = Service.getdetails();		
		return get;
}
@GetMapping("/Expenses/{id}")
	public  Expenses  getdetailsbyId(@PathVariable Integer id ) {
		Expenses  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Expenses/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}







}